package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.user.bo.UserUpdateAddBo;
import com.zhongzheng.modules.user.bo.UserUpdateQueryBo;
import com.zhongzheng.modules.user.bo.UserUpdateEditBo;
import com.zhongzheng.modules.user.domain.UserUpdate;
import com.zhongzheng.modules.user.mapper.UserUpdateMapper;
import com.zhongzheng.modules.user.vo.UserUpdateVo;
import com.zhongzheng.modules.user.service.IUserUpdateService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户修改记录Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-23
 */
@Service
public class UserUpdateServiceImpl extends ServiceImpl<UserUpdateMapper, UserUpdate> implements IUserUpdateService {

    @Override
    public UserUpdateVo queryById(Long id){
        UserUpdate db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, UserUpdateVo.class);
    }

    @Override
    public List<UserUpdateVo> queryList(UserUpdateQueryBo bo) {
        LambdaQueryWrapper<UserUpdate> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, UserUpdate::getUserId, bo.getUserId());
        lqw.like(StrUtil.isNotBlank(bo.getRealname()), UserUpdate::getRealname, bo.getRealname());
        lqw.eq(StrUtil.isNotBlank(bo.getIdCard()), UserUpdate::getIdCard, bo.getIdCard());
        lqw.eq(StrUtil.isNotBlank(bo.getTelphone()), UserUpdate::getTelphone, bo.getTelphone());
        lqw.orderByDesc(UserUpdate::getCreateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserUpdateVo> entity2Vo(Collection<UserUpdate> collection) {
        List<UserUpdateVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserUpdateVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserUpdate> page = (Page<UserUpdate>)collection;
            Page<UserUpdateVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserUpdateAddBo bo) {
        UserUpdate add = BeanUtil.toBean(bo, UserUpdate.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserUpdateEditBo bo) {
        UserUpdate update = BeanUtil.toBean(bo, UserUpdate.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserUpdate entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
